<template>
  <div class="px-5">
    <v-row justify="center" class="mt-2 grey lighten-3 pa-12">
      <v-col cols="12" sm="10" class="white">
        <v-card class="card d-flex flex-wrap mx-3" color="primary" dark>
          <v-col class="text-center" cols="12">
            <span class="subtitle-1">
              LEAVE DETAILS
            </span>
          </v-col>
        </v-card>
        <v-card flat tile class="ma-3">
          <p class="subtitle-1">
            <span class="font-weight-bold mr-2">Employee Name : </span>
            {{ firstname }} {{ lastname }}
          </p>
          <p class="subtitle-1">
            <span class="font-weight-bold mr-2">Employee ID :  </span>
            {{ employeecode }}
          </p>
          <p class="subtitle-1">
            <span class="font-weight-bold mr-2">Department : </span>
            {{ department }}
          </p>
          <p class="subtitle-1">
            <span class="font-weight-bold mr-2">Mobile Number : </span>
            {{ mobilenumber }}
          </p>
          <p>
            <span class="font-weight-bold mr-2">Leave Type : </span>
            {{ leavetype }}
          </p>
          <p>
            <span class="font-weight-bold mr-2">Posting Date : </span>
            {{ dateCreated }}
          </p>
          <p>
            <span class="font-weight-bold mr-2">Date of Absense : </span>
            <span class="font-weight-bold mr-2">from : </span>
            {{ from }}
            <span class="font-weight-bold mr-2">to : </span>
            {{ to }}
          </p>
          <p>
            <span class="font-weight-bold mr-2">Employee Leave Description : </span>
            {{ description }}
          </p>
          <p>
            <span class="font-weight-bold mr-2">Leave Status : </span>
            <v-chip :color="getColor(status)" class="black--text">{{ status }}</v-chip>
          </p>
          <p>
            <span class="font-weight-bold mr-2">Management Remark : </span>
            {{ remark }}
          </p>
          <v-card-actions>
            <v-btn
              class="secoundary white--text ma-2"
              dark
              v-on:click="takeAction"
            >
              Take Action
            </v-btn>
            <v-btn
              class="warning white--text ma-2"
              dark
              v-on:click="cancel"
            >
              Cancel
            </v-btn>
          </v-card-actions>
        </v-card>
        <v-dialog
          v-model="show"
          max-width="800px"
        >
          <v-card>
            <v-card-title>
              Leave Take Action
            </v-card-title>
            <v-card-text>
              <v-select
                :items="select"
                label="Choose Your Option"
                :value="status"
                @change="$emit('update:status', $event)"
              ></v-select>
              <v-textarea
                label="Remark"
                :value="remark"
                @change="$emit('update:remark', $event)"
              >
              </v-textarea>
            </v-card-text>
            <v-card-actions>
              <v-btn
                color="secoundary"
                text
                v-on:click="close"
              >
                Close
              </v-btn>
              <v-btn
                color="secoundary"
                text
                :loading="loading"
                v-on:click="submit"
              >
                Submit
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-col>
    </v-row>
  </div>
</template>
<script>

export default {
  data() {
    return {
      select: [
        { text: 'Awaiting Approval' },
        { text: 'Approved' },
        { text: 'Disproved' },
      ],
    };
  },
  props: {
    employeecode: {
      type: String,
      required: false,
    },
    department: {
      type: String,
      required: false,
    },
    firstname: {
      type: String,
      default: '',
      required: false,
    },
    lastname: {
      type: String,
      required: true,
    },
    mobilenumber: {
      type: String,
      required: true,
    },
    loading: {
      type: Boolean,
      required: false,
    },
    leavetype: {
      type: String,
      required: true,
    },
    from: {
      type: String,
      required: true,
    },
    to: {
      type: String,
      required: true,
    },
    description: {
      type: String,
      required: true,
    },
    status: {
      type: String,
      required: true,
    },
    dateCreated: {
      type: String,
      required: false,
    },
    remark: {
      type: String,
      required: false,
    },
    show: {
      type: Boolean,
      default: false,
    },
  },
  methods: {
    takeAction() {
      this.$emit('takeAction');
    },
    cancel() {
      this.$emit('cancel');
    },
    submit() {
      this.$emit('submit');
    },
    close() {
      this.$emit('close');
    },
    getColor(status) {
      if (status === 'Awaiting Approval') {
        return 'info';
      } if (status === 'Approved') {
        return 'success';
      }
      return 'error';
    },
  },
};
</script>

<style scoped>
.card {
  top: -20px;
}
</style>
